;============================================
; ============== MPC ZONE ==================
;============================================    
meu_computador_process_init:
     LD  BC,meu_computador_process_end - meu_computador_var
meu_computador_main_task:
     XOR   A
     LD    HL,$9D95+((meu_computador_var - meu_computador_main_task)-1)
     LD    A,(HL)
     CP    1 \ jr  z,continuar_process
     LD    A,1
     LD    (HL),A
     LD    HL,$9D95+((background_mpc - meu_computador_main_task)-1)
     XOR   A
     invoke( ADD_program_to_background )
     XOR   A
continuar_process:     
     LD    HL,$9D95+((pastacoord1x - meu_computador_main_task)-1)
     LD    (HL),A
     LD    HL,$9D95+((pastacoord1y - meu_computador_main_task)-1)
     LD    (HL),A
     LD    A,57
     LD    HL,$9D95+((pastacoord2y - meu_computador_main_task)-1)
     LD    (HL),A
     LD    A,96
     LD    HL,$9D95+((pastacoord2x - meu_computador_main_task)-1)
     LD    (HL),A
     LD    HL,$9D95+((var1 - meu_computador_main_task)-1) ;aponta para a primeira variavel
     LD    A,(HL)
     OR    A \ jp   z,$9D95+((main_activ-meu_computador_main_task)-1)
     CP    1 \ jp   z,$9D95+((macro_die_pasta-meu_computador_main_task)-1)
     CP    2 \ jp   z,$9D95+((todos_pasta-meu_computador_main_task)-1)
     CP    3 \ jp   z,$9D95+((screen_savers_pasta-meu_computador_main_task)-1)
     CP    4 \ jp   z,$9D95+((microprocessador_pasta-meu_computador_main_task)-1)
defenicoes_pasta:
     xor   a
     invoke( create_default_pasta )
;screen frequency = 44Hz
;screen_driver:  .db "Screen driver Toshiba T6A04",0
;macrodie        .db "MacroDie OS 1.0",0
;screen_freq:    .db "Screen Frequency 44Hz",0
    DI
    set  textwrite, (IY + SGRFLAGS)
    LD   HL,$9D95+((macrodie-meu_computador_main_task)-1)
    ;LD   DE,buffer
    ;LD   BC,screen_freq - macrodie
    ;LDIR
    LD   DE,$0903
    LD   (_penCol),DE
    ;LD   HL,buffer;temp storage
    bcall _VPutS    
    LD   HL,$9D95+((screen_driver-meu_computador_main_task)-1)
    ;LD   DE,buffer
    ;LD   BC,macrodie - screen_driver
    ;LDIR 
    LD   DE,$1003
    LD   (_penCol),DE
    ;LD   HL,buffer
    bcall _VPutS 
    LD   HL,$9D95+((screen_freq-meu_computador_main_task)-1)
    ;LD   DE,buffer
    ;LD   BC,macrodie_text - screen_freq
    ;LDIR 
    LD   DE,$1603
    LD   (_penCol),DE
    ;LD   HL,buffer
    bcall _VPutS
    EI;screen updated
    xor  a
    invoke( fastcopy )
    res  plotLoc, (IY + plotFlags)
    LD   H,9
    LD   L,2
    LD   D,64-10
    LD   E,93
    bcall _Invertrect
    IM   2
    set  plotLoc, (IY + plotFlags)
    res  textwrite, (IY + SGRFLAGS)
    xor  a
    invoke( mouse )
defenicoes_pasta_1:
    xor   a
    invoke( window_verif_coords )
    LD    A,B
    CP    1 \ jp   z,((fechar_tarefa - meu_computador_main_task) - 1) + $9D95    
    CP    2 \ jp   z,((minimizar_tarefa - meu_computador_main_task) - 1) + $9D95
    CP    3 \ jp   z,((mudar_para_main - meu_computador_main_task) - 1) + $9D95
    CP    5 \ jp   z,((minimizar_tarefa - meu_computador_main_task) - 1) + $9D95;provocando o mouse na barra de tarefas logo temos de mudar para o explorer
    XOR   A
    invoke( loop )
    jr    defenicoes_pasta_1
;###########################
;#### ScreenSaver Pasta ####
;###########################
screen_savers_pasta:
    LD   HL,$9D95+((page_counter2 - meu_computador_main_task)-1)
    LD   A,1
    LD   (HL),A  
    LD   A,90
    LD   (scroll_x),A
    LD   A,6+9
    LD   (scroll_y),A;valores resetados por default
    XOR  A
    invoke( create_default_pasta )
    LD   B,$28
    XOR  A
    invoke( count_Prgms );retorna o valor de programas em A
    LD   HL,((number_of_progs - meu_computador_main_task)-1)+$9D95
    LD   C,A
    LD   (HL),A
    LD   A,B;erro no sistema sim ou nao
    CP   2 \ jp   z,((error_overflowed3 - meu_computador_main_task)-1)+$9D95
    LD   A,C
    LD   HL,$9D95+((counter1 - meu_computador_main_task)-1)
    LD   (HL),A;numero de progs salvo
    cp   11 \ PUSH AF;salvo o registo de flags 
            \ LD   A,0
            \ LD   B,A
            jr     c,do_not_invoke_4
            \ invoke( redraw_cursor_bar )
do_not_invoke_4:            
            \ POP  AF
            \ PUSH AF
            \ jr   nc,do_not_erase_L2
              LD   L,2
do_not_erase_L2:  
              LD   A,L;numero de paginas na parte baixa de HL
              DEC  A
              LD   HL,$9D95+((page_counter2 - meu_computador_main_task)-1)
              LD   (HL),A;numero de paginas salvo
              POP  AF;restauro o registo de flags
              LD   B,0;comeamos na pagina 0
              LD   A,B
              jr   c,do_not_invoke_5
            \ invoke( update_scroll_pointer )
do_not_invoke_5   
redraw_screen_display3:
    LD   A,(scroll_x)
    LD   HL,$9D95+((scroll_x1 - meu_computador_main_task)-1)
    LD   (HL),A
    INC  HL
    LD   A,(scroll_y)
    LD   (HL),A
    DEC  HL
    DEC  HL
    DEC  HL
    PUSH HL
    LD   HL,(bar_size)
    EX   DE,HL;DE com o bar size
    POP  HL
    LD   A,E
    LD   (HL),A
    LD   A,D
    INC  HL
    LD   (HL),A
    LD   A,2
    LD   (scroll_x),A
    LD   A,14
    LD   (scroll_y),A
    ;DI;desactivo os interrupts o que causa a interrupcao de todos os programas activos mas tem de ser
    LD   B,$28;tenho de procurar por shell programs
    XOR  A
    invoke( search_and_display_programs )
    LD   A,B
    ;EI
    CP   2 \ jr z,screensavers_mouse
    LD   IX,$9D95+((_OP1_register_save - meu_computador_main_task)-1);11 bytes
    XOR  A
    invoke( save_Op1_register_to_memory )
    LD   A,(temp_C);obtenho o numero de programas que sobrou possivelmente pode ser a ultima pagina e nao esta
    ;preenchida por isso obtenho o numero de programas que ficou por dispar e subtrai-o a 10
    LD   L,A
    LD   A,10
    SUB  L;faco a subtracao
    LD   HL,$9D95+((counter2 - meu_computador_main_task)-1)
    LD   (HL),A
screensavers_mouse:    
    XOR  A
    invoke( mouse )
screensavers_mouse_verif:    
    XOR  A
    invoke( window_verif_coords )
    LD    A,B
screensavers_mouse_verif_coo:    
    CP    1 \ jp   z,((fechar_tarefa-meu_computador_main_task)-1)+$9D95    
    CP    2 \ jp   z,((minimizar_tarefa-meu_computador_main_task)-1)+$9D95
    CP    3 \ jp   z,((mudar_para_main - meu_computador_main_task)-1)+$9D95
    CP    4 \ jp   z,((mudar_para_screensavers - meu_computador_main_task)-1)+$9D95
    CP    5 \ jp   z,((minimizar_tarefa-meu_computador_main_task)-1)+$9D95;provocando o mouse na barra de tarefas logo temos de mudar para o explorer
    XOR   A
    invoke( verif_scroll_bar )
    CP    1 \ jr   z,scroll_up13
    CP    2 \ jp   z,((scroll_down13-meu_computador_main_task)-1)+$9D95
;verificar icone
    XOR   A
    invoke( find_icone );obtenho o icone em B
    PUSH  BC;salvo o numero do icone para usar depois
    LD    HL,$9D95+((page_counter1 - meu_computador_main_task)-1);tenho o numero da pagina onde estou
    LD    A,(HL)
    OR    A \ jr   z,pagina_zero1;se estou na pagina zero o icone e o numero do prog
    DEC   A;decremento uma pagina pois nao posso contar com a pagina onde estou
    LD    B,A
    XOR   A;apago o A
    LD    C,A;apago o C
start_conting1:;comeco a contar o numero de paginas
    LD    A,C
    ADD   A,10;somo 10 por cada pagina
    DEC   B
    LD    C,A;salvo o A
    LD    A,B
    OR    A \ jr  nz,start_conting1
    LD    A,C;paso o numero de programas para A pois vou restaurar o B e o C
pagina_zero1:    
    POP   BC
    LD    C,A
    LD    A,B
    OR    A
    jp    z,((mudar_screensavers_nothing-meu_computador_main_task)-1)+$9D95
    LD    A,C
    ADD   A,B;somo o numero de programas com o numero do icone e obtenho o numero do programa que tenho de procurar
    LD    B,A
    LD   HL,((number_of_progs - meu_computador_main_task)-1)+$9D95
    LD    A,(HL)
    CP    B \ jp  c,((mudar_screensavers_nothing-meu_computador_main_task)-1)+$9D95
    
    LD    C,$18;tenho de procurar programas com shell de $18 'jr'
    XOR   A
    invoke( search_VAT_for_prog );retorna nome do programa em OP1
    jp    c,((mudar_screensavers_nothing-meu_computador_main_task)-1)+$9D95;caso esta flag esteja activa e porque o programa teve um erro e tem de voltar sem erros
    XOR   A
    invoke( CheckFreeMem );tenho de obter a memoria disponivel para nova tarefa o espaco livre vem em HL
    LD    (free_memory),HL;o espaco da memoria ram disponivel
    bcall _ChkFindSym;como a routina anterior obtem apenas programas nao preciso de fazer AND $1F
    LD    HL,$9D95+((screensavers_mouse - meu_computador_main_task)-1);se existir erro volto a traz
    jp    c,((mudar_screensavers_nothing-meu_computador_main_task)-1)+$9D95;caso esta flag esteja activa e porque o programa teve um erro e tem de voltar sem erros
    LD    A,$03
    LD    (type_of_task),A
    XOR   A
    invoke( compile_thread_to_mem );Inputs 
    XOR   A
    LD    (close_task),A
    LD    (screen),A
    LD    A,(last_activ_process)
    LD    (activ_task),A
    RET
scroll_up13:
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   A,(HL)
    CP   0 \ jp   z,((mudar_screensavers_nothing-meu_computador_main_task)-1)+$9D95
    DEC  A
    LD   (HL),A
    CP   0
    PUSH AF
    XOR  A
    invoke( folder_ram_cleaner )
    LD   IX,$9D95+((_OP1_register_save - meu_computador_main_task)-1);11 bytes
    XOR  A
    invoke( restore_Op1_register_from_memory )
    LD   HL,$9D95+((counter2 - meu_computador_main_task)-1)
    LD   A,(HL);numero de progs em A
    LD   B,A
    LD   C,$28
    XOR  A
    invoke( search_VAT_UP_11_times );procura VAT em ordem ascendente
    XOR  A
    invoke( draw_bar )
    LD   HL,$9D95+((bar_size1 - meu_computador_main_task)-1)
    LD   A,(HL);lsb come first
    LD   E,A
    INC  HL
    LD   A,(HL)
    LD   D,A;msb comes now now i ve the bar size in DE
    LD   (bar_size),DE;the size have been restructured
    INC  HL;HL now points to scroll_x1
    LD   A,(HL)
    LD   (scroll_x),A
    INC  HL
    LD   A,(HL);HL now points to scroll_y1
    LD   (scroll_y),A
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   B,(HL)
    XOR  A
    invoke( update_scroll_pointer )
    LD   A,2
    LD   (scroll_x),A
    LD   A,17
    LD   (scroll_y),A
    LD   A,$28
    LD   (var_flag2),A;salvo o tipo de programa a procurar
    LD   A,10
    LD   (temp_C),A
    POP  AF
    
    ;*********************************************************************************************************************
    
    LD   A,0
    jr   nz,do_not_invoke_6
    invoke( first_search_op1 )
do_not_invoke_6:    
    XOR  A
    invoke( searching_and_displaying )
    LD   IX,$9D95+((_OP1_register_save - meu_computador_main_task)-1);11 bytes
    XOR  A
    invoke( save_Op1_register_to_memory )
error_overflowed3:
    jp   ((mudar_screensavers_nothing-meu_computador_main_task)-1)+$9D95
scroll_down13:    
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   A,(HL)
    LD   B,A; o numero da pagina actual em B
    LD   HL,$9D95+((page_counter2 - meu_computador_main_task)-1)
    LD   A,(HL);numero total de paginas em A
    CP   B \ jr  c,mudar_screensavers_nothing;nao pode acontecer 
           \ jr  z,mudar_screensavers_nothing;nao pode acontecer
    INC  B
    LD   A,B
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   (HL),A
    XOR  A
    invoke( folder_ram_cleaner )
    LD   IX,$9D95+((_OP1_register_save - meu_computador_main_task)-1);11 bytes
    PUSH IX
    XOR  A
    invoke( restore_Op1_register_from_memory )
    LD   A,$28
    PUSH AF
    PUSH HL
    LD   A,2
    LD   (scroll_x),A
    LD   A,17
    LD   (scroll_y),A
    POP  HL
    POP  AF
    LD   (var_flag2),A;salvo o tipo de programa a procurar
    LD   A,10
    LD   (temp_C),A
    LD   A,$18
    XOR  A
    invoke( searching_and_displaying )
    POP  IX
    PUSH BC;salvo a mensagem de erro
    XOR  A
    invoke( save_Op1_register_to_memory )
    POP  BC 
    LD   A,B
    CP   2 \ jr     z,mudar_screensavers_nothing
    XOR  A
    invoke( draw_bar )
    LD   HL,$9D95+((bar_size1 - meu_computador_main_task)-1)
    LD   A,(HL);lsb come first
    LD   E,A
    INC  HL
    LD   A,(HL)
    LD   D,A;msb comes now now i ve the bar size in DE
    LD   (bar_size),DE;the size have been restructured
    INC  HL;HL now points to scroll_x1
    LD   A,(HL)
    LD   (scroll_x),A
    INC  HL
    LD   A,(HL);HL now points to scroll_y1
    LD   (scroll_y),A
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   B,(HL)
    XOR  A
    invoke( update_scroll_pointer )    
mudar_screensavers_nothing:
    XOR  A
    invoke( loop )
    jp ((screensavers_mouse_verif - meu_computador_main_task)-1)+$9D95
mudar_para_screensavers:
    XOR  A
    invoke( mouse_sprite )
    jp   ((screensavers_mouse-meu_computador_main_task)-1)+$9D95
    







todos_pasta:
    LD   HL,$9D95+((page_counter2 - meu_computador_main_task)-1)
    LD   A,1
    LD   (HL),A  
    LD   A,90
    LD   (scroll_x),A
    LD   A,6+9
    LD   (scroll_y),A;valores resetados por default
    XOR  A
    
    invoke( create_default_pasta )
    XOR  A
    LD   B,A
    invoke( count_Prgms );retorna o valor de programas em A
    LD   C,A
    LD   A,B
    CP   2 \ jp   z,((error_overflowed1 - meu_computador_main_task)-1)+$9D95
    LD   A,C
    LD   HL,$9D95+((counter1 - meu_computador_main_task)-1)
    LD   (HL),A;numero de progs salvo
    cp   11 \ PUSH AF;salvo o registo de flags
            \ LD   B,A
            \ LD   A,0
              jr   c,do_not_invoke_7
            \ invoke( redraw_cursor_bar );redesenha a bar de deslocamento 
do_not_invoke_7:            
            \ POP  AF
            \ PUSH AF
            \ jr   nc,do_not_erase_L1
              LD   L,2
do_not_erase_L1:
              LD   A,L;numero de paginas na parte baixa de HL
              DEC  A
              LD   HL,$9D95+((page_counter2 - meu_computador_main_task)-1)
              LD   (HL),A;numero de paginas salvo
              POP  AF;restauro o registo de flags
              LD   B,0;comeamos na pagina 0
            \ LD   A,B
              jr   c,redraw_screen_display1
            \ invoke( update_scroll_pointer )
redraw_screen_display1:
    XOR  A
    invoke( fastcopy )
    LD   A,(scroll_x)
    LD   HL,$9D95+((scroll_x1 - meu_computador_main_task)-1)
    LD   (HL),A
    INC  HL
    LD   A,(scroll_y)
    LD   (HL),A
    DEC  HL
    DEC  HL
    DEC  HL
    PUSH HL
    LD   HL,(bar_size)
    EX   DE,HL;DE com o bar size
    POP  HL
    LD   A,E
    LD   (HL),A
    LD   A,D
    INC  HL
    LD   (HL),A
    LD   A,2
    LD   (scroll_x),A
    LD   A,14
    LD   (scroll_y),A
    ;DI;desactivo os interrupts o que causa a interrupcao de todos os programas activos mas tem de ser
    XOR  A
    LD   B,A
    invoke( search_and_display_programs )
    PUSH BC
    XOR  A
    invoke( fastcopy )
    pop bc
    
    LD   A,B
    ;EI
    CP   2 \ jr z,todos_mouse
    LD   IX,$9D95+((_OP1_register_save - meu_computador_main_task)-1);11 bytes
    XOR  A
    invoke( save_Op1_register_to_memory )
    LD   A,(temp_C);obtenho o numero de programas que sobrou possivelmente pode ser a ultima pagina e nao esta
    ;preenchida por isso obtenho o numero de programas que ficou por dispar e subtrai-o a 10
    LD   L,A
    LD   A,10
    SUB  L;faco a subtracao
    LD   HL,$9D95+((counter2 - meu_computador_main_task)-1)
    LD   (HL),A
    xor   a
    invoke( fastcopy )
todos_mouse:
    XOR  A
    invoke( mouse )
todos_mouse_verif:
    XOR  A   
    invoke( window_verif_coords )
    LD    A,B
todos_mouse_verif_coo:    
    CP    1 \ jp   z,((fechar_tarefa-meu_computador_main_task)-1)+$9D95    
    CP    2 \ jp   z,((minimizar_tarefa-meu_computador_main_task)-1)+$9D95
    CP    3 \ jp   z,((mudar_para_main-meu_computador_main_task)-1)+$9D95
    CP    4 \ jp   z,((mudar_para_todos-meu_computador_main_task)-1)+$9D95
    CP    5 \ jp   z,((minimizar_tarefa-meu_computador_main_task)-1)+$9D95;provocando o mouse na barra de tarefas logo temos de mudar para o explorer
    XOR   A
    invoke( verif_scroll_bar )
    CP    1 \ jr   z,scroll_up122
    CP    2 \ jp   z,((scroll_down122-meu_computador_main_task)-1)+$9D95
    jp  ((mudar_todos_nothing-meu_computador_main_task)-1)+$9D95
    
scroll_up122:
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   A,(HL)
    OR   A
    jp   z,((mudar_todos_nothing-meu_computador_main_task)-1)+$9D95
    DEC  A
    LD   (HL),A
    OR   A
    PUSH AF
    XOR  A
    invoke( folder_ram_cleaner )
    LD   IX,$9D95+((_OP1_register_save - meu_computador_main_task)-1);11 bytes
    XOR  A
    invoke( restore_Op1_register_from_memory )
    LD   HL,$9D95+((counter2 - meu_computador_main_task)-1)
    LD   A,(HL);numero de progs em A
    LD   B,A
    XOR  A
    LD   C,A
    invoke( search_VAT_UP_11_times );procura VAT em ordem ascendente
    XOR  A
    invoke( draw_bar )
    LD   HL,$9D95+((bar_size1 - meu_computador_main_task)-1)
    LD   A,(HL);lsb come first
    LD   E,A
    INC  HL
    LD   A,(HL)
    LD   D,A;msb comes now now i ve the bar size in DE
    LD   (bar_size),DE;the size have been restructured
    INC  HL;HL now points to scroll_x1
    LD   A,(HL)
    LD   (scroll_x),A
    INC  HL
    LD   A,(HL);HL now points to scroll_y1
    LD   (scroll_y),A
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   B,(HL)
    XOR  A
    invoke( update_scroll_pointer )
    LD   A,2
    LD   (scroll_x),A
    LD   A,17
    LD   (scroll_y),A
    XOR  A
    LD   (var_flag2),A;salvo o tipo de programa a procurar
    LD   A,10
    LD   (temp_C),A
    POP  AF
    LD   A,0
    jr   nz,do_not_invoke_8
    invoke( first_search_op1 )
do_not_invoke_8:
    XOR  A
    invoke( searching_and_displaying_1 )
    LD   IX,$9D95+((_OP1_register_save - meu_computador_main_task)-1);11 bytes
    XOR  A
    invoke( save_Op1_register_to_memory )
    LD   A,(temp_C);obtenho o numero de programas que sobrou possivelmente pode ser a ultima pagina e nao esta
    ;preenchida por isso obtenho o numero de programas que ficou por dispar e subtrai-o a 10
    LD   L,A
    LD   A,10
    SUB  L;faco a subtracao
    LD   HL,$9D95+((counter2 - meu_computador_main_task)-1)
    LD   (HL),A
error_overflowed1:
    jp   ((mudar_todos_nothing-meu_computador_main_task)-1)+$9D95
scroll_down122:    
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   A,(HL)
    LD   B,A; o numero da pagina actual em B
    LD   HL,$9D95+((page_counter2 - meu_computador_main_task)-1)
    LD   A,(HL);numero total de paginas em A
    CP   B \ jr  c,mudar_todos_nothing;nao pode acontecer 
           \ jr  z,mudar_todos_nothing;nao pode acontecer
    INC  B
    LD   A,B
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   (HL),A
    XOR  A
    invoke( folder_ram_cleaner )
    LD   IX,$9D95+((_OP1_register_save - meu_computador_main_task)-1);11 bytes
    PUSH IX
    XOR  A
    invoke( restore_Op1_register_from_memory )
    PUSH HL
    LD   A,2
    LD   (scroll_x),A
    LD   A,17
    LD   (scroll_y),A
    POP  HL
    XOR  A
    LD   (var_flag2),A;salvo o tipo de programa a procurar
    LD   A,10
    LD   (temp_C),A
    XOR  A
    invoke( searching_and_displaying_1 )
    POP  IX
    PUSH BC;salvo a mensagem de erro
    XOR  A
    invoke( save_Op1_register_to_memory )
    POP  BC 
    LD   A,B
    CP   2 \ jr     z,mudar_todos_nothing
    XOR  A
    invoke( draw_bar )
    LD   HL,$9D95+((bar_size1 - meu_computador_main_task)-1)
    LD   A,(HL);lsb come first
    LD   E,A
    INC  HL
    LD   A,(HL)
    LD   D,A;msb comes now now i ve the bar size in DE
    LD   (bar_size),DE;the size have been restructured
    INC  HL;HL now points to scroll_x1
    LD   A,(HL)
    LD   (scroll_x),A
    INC  HL
    LD   A,(HL);HL now points to scroll_y1
    LD   (scroll_y),A
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   B,(HL)
    XOR  A
    invoke( update_scroll_pointer )
    LD   A,(temp_C);obtenho o numero de programas que sobrou possivelmente pode ser a ultima pagina e nao esta
    ;preenchida por isso obtenho o numero de programas que ficou por dispar e subtrai-o a 10
    LD   L,A
    LD   A,10
    SUB  L;faco a subtracao
    LD   HL,$9D95+((counter2 - meu_computador_main_task)-1)
    LD   (HL),A   
mudar_todos_nothing:
    XOR  A
    invoke( loop )
    jp ((todos_mouse_verif - meu_computador_main_task)-1)+$9D95    
mudar_para_todos:
    XOR  A
    invoke( mouse_sprite )
    jp   ((todos_mouse-meu_computador_main_task)-1)+$9D95    
    
    
    
    
    
    
    
    
    

microprocessador_pasta:
microprocessador2:
   XOR  A
   invoke( create_default_pasta )
draw_screen_info:
    set textwrite,(IY + SGRFLAGS)
    DI
    LD   HL,((CPU_name - meu_computador_main_task) - 1) + $9D95
    ;LD   DE,buffer
    ;LD   BC,$0007
    ;LDIR;copy it
    ;LD   HL,buffer
    LD   DE,$0903
    LD   (_penCol),DE
    bcall _VPutS
    LD  HL,((background_refresh - meu_computador_main_task) - 1 ) + $9D95
    LD  DE,$1703
    LD  (_penCol),DE
    bcall _VPutS
    IN   A,(20h)
    bit  0,A
    jr   z,_6_MHz_speed
_15_MHz_speed:
    LD   HL,((speed_15MHz - meu_computador_main_task) - 1) + $9D95
    ;LD   DE,buffer
    ;LD   BC,9
    ;LDIR
    LD   DE,$1003
    LD   (_penCol),DE
    ;LD   HL,buffer
    bcall _VPutS
    LD   A,'-'
    bcall _VPutMap
    jr   continuar_micro_pasta
_6_MHz_speed:
    LD   HL,((speed_6MHz - meu_computador_main_task) - 1) + $9D95
    ;LD   DE,buffer
    ;LD   BC,9
    ;LDIR
    LD   DE,$1007
    LD   (_penCol),DE
    ;LD   HL,buffer
    bcall _VPutS
    LD   A,'+'
    bcall _VPutMap
continuar_micro_pasta:
    LD   DE,$1E03
    LD   (_penCol),DE
    IN   A,(4)
    bit  2,A
    jr   nz,put_a_zero_on_screen
put_a_3_on_screen:
    LD   A,'3'
    bcall _VPutMap;display interrupts speed
    LD   DE,$1E07
    LD   (_penCol),DE
    LD    A,'-'
    bcall _VPutMap
    jr   continuar_display_back_speed
put_a_zero_on_screen:
    LD   A,'0'
    bcall _VPutMap;display interrupts speed
    LD   DE,$1E07
    LD   (_penCol),DE
    LD    A,'+'
    bcall _VPutMap
continuar_display_back_speed:
    ;interrupt speed enabled
    LD   DE,$2503
    LD   (_penCol),DE
    LD   HL,save_screen_name
    bcall _VPutS
    EI
    XOR  A
    invoke( fastcopy )
    res textwrite,(IY + SGRFLAGS)
    res  plotLoc, (IY + plotFlags)
    LD   H,9
    LD   L,2
    LD   D,64-10
    LD   E,93
    bcall _Invertrect
    IM   2
    set  plotLoc, (IY + plotFlags)
    XOR  A
    invoke( mouse )
micro_pasta_verif_coords:
    XOR  A
    invoke( window_verif_coords )
    LD    A,B
    CP    1 \ jp   z,((fechar_tarefa - meu_computador_main_task) - 1) + $9D95    
    CP    2 \ jp   z,((minimizar_tarefa - meu_computador_main_task) - 1) + $9D95
    CP    3 \ jp   z,((mudar_para_main - meu_computador_main_task) - 1) + $9D95
    CP    5 \ jp   z,((minimizar_tarefa - meu_computador_main_task) - 1) + $9D95;provocando o mouse na barra de tarefas logo temos de mudar para o explorer
    LD    A,(ypos)
    CP    $10
    jr    c,continuar_micro_pasta1
    cp    $10 + $07
    jr    nc,check_interrupt_speed
    LD    A,(xpos)
    cp    24 \ jr c,continuar_micro_pasta1
    cp    28 \ jr nc,continuar_micro_pasta1
detect_speed 
    IN    A,(20h)
    bit   0,A
    jr    z,colocar_a_15MHz 
colocar_a_6MHz:
    XOR   A
    OUT   (20h),A
    ;retirar atraso para 6MHz
saltar_micor:
    jp    ((microprocessador2 - meu_computador_main_task) - 1) + $9D95
colocar_a_15MHz:
    LD    A,1
    OUT   (20h),A
    ;colocar valor para qualquer tipo de speed
    jr    saltar_micor
continuar_micro_pasta1:
    XOR   A
    invoke( loop )
    jr    micro_pasta_verif_coords 
check_interrupt_speed:
    CP    $1E        \ jr  c,continuar_micro_pasta1
    CP    $1E + $07  \ jr  nc,continuar_micro_pasta1
    LD    A,(xpos)
    CP    $07        \ jr  c,continuar_micro_pasta1
    CP    $07 + $04  \ jr  nc,continuar_micro_pasta1
;detect speed and change it
    DI
    IN    A,(4)
    bit   2,A
    jr    nz,set_0
set_1:
    LD    A,%00000110
    jr    set_
set_0:
    XOR   A
set_:
    OUT   (4),A
    EI
    jr    saltar_micor
;========================================================
;=============== MacroDie Pasta process =================
;========================================================
macro_die_pasta:
    LD   HL,$9D95+((page_counter2 - meu_computador_main_task)-1)
    LD   A,1
    LD   (HL),A  
    LD   A,90
    LD   (scroll_x),A
    LD   A,6+9
    LD   (scroll_y),A;valores resetados por default
    XOR  A
    invoke( create_default_pasta )
    LD   B,$18
    XOR  A
    invoke( count_Prgms );retorna o valor de programas em A
    LD   HL,((number_of_progs - meu_computador_main_task)-1)+$9D95
    LD   C,A
    LD   (HL),A
    LD   A,B;erro no sistema sim ou nao
    CP   2 \ jp   z,((error_overflowed - meu_computador_main_task)-1)+$9D95
    LD   A,C
    LD   HL,$9D95+((counter1 - meu_computador_main_task)-1)
    LD   (HL),A;numero de progs salvo
    cp   11 \ PUSH AF;salvo o registo de flags  
            \ LD   B,A
            \ LD   A,0
              jr   c,do_not_invoke_9
            \ invoke( redraw_cursor_bar );redesenha a bar de deslocamento
do_not_invoke_9:            
            \ POP  AF
            \ PUSH AF
            \ jr   nc,do_not_erase_L
              LD   L,2
do_not_erase_L:
              LD   A,L;numero de paginas na parte baixa de HL
              DEC  A
              LD   HL,$9D95+((page_counter2 - meu_computador_main_task)-1)
              LD   (HL),A;numero de paginas salvo
              POP  AF;restauro o registo de flags
              LD   A,0;comeamos na pagina 0
            \ LD   B,A
              jr   c,redraw_screen_display
            \ invoke( update_scroll_pointer )
redraw_screen_display:
    LD   A,(scroll_x)
    LD   HL,$9D95+((scroll_x1 - meu_computador_main_task)-1)
    LD   (HL),A
    INC  HL
    LD   A,(scroll_y)
    LD   (HL),A
    DEC  HL
    DEC  HL
    DEC  HL
    PUSH HL
    LD   HL,(bar_size)
    EX   DE,HL;DE com o bar size
    POP  HL
    LD   A,E
    LD   (HL),A
    LD   A,D
    INC  HL
    LD   (HL),A
    LD   A,2
    LD   (scroll_x),A
    LD   A,14
    LD   (scroll_y),A
    ;DI;desactivo os interrupts o que causa a interrupcao de todos os programas activos mas tem de ser
    LD   B,$18;tenho de procurar por shell programs
    XOR  A
    invoke( search_and_display_programs )
    LD   A,B
    ;EI
    CP   2 \ jr z,macrodie_mouse
    LD   IX,$9D95+((_OP1_register_save - meu_computador_main_task)-1);11 bytes
    XOR  A
    invoke( save_Op1_register_to_memory )
    LD   A,(temp_C);obtenho o numero de programas que sobrou possivelmente pode ser a ultima pagina e nao esta
    ;preenchida por isso obtenho o numero de programas que ficou por dispar e subtrai-o a 10
    LD   L,A
    LD   A,10
    SUB  L;faco a subtracao
    LD   HL,$9D95+((counter2 - meu_computador_main_task)-1)
    LD   (HL),A
macrodie_mouse:
    XOR  A    
    invoke( mouse )
macrodie_mouse_verif:
    XOR  A    
    invoke( window_verif_coords )
    LD    A,B
macrodie_mouse_verif_coo:    
    CP    1 \ jp   z,((fechar_tarefa-meu_computador_main_task)-1)+$9D95    
    CP    2 \ jp   z,((minimizar_tarefa-meu_computador_main_task)-1)+$9D95
    CP    3 \ jp   z,((mudar_para_main - meu_computador_main_task)-1)+$9D95
    CP    4 \ jp   z,((mudar_para_macrodie - meu_computador_main_task)-1)+$9D95
    CP    5 \ jp   z,((minimizar_tarefa-meu_computador_main_task)-1)+$9D95;provocando o mouse na barra de tarefas logo temos de mudar para o explorer
    XOR   A
    invoke( verif_scroll_bar )
    CP    1 \ jr   z,scroll_up12
    CP    2 \ jp   z,((scroll_down12-meu_computador_main_task)-1)+$9D95
;verificar icone
    XOR   A
    invoke( find_icone );obtenho o icone em B
    PUSH  BC;salvo o numero do icone para usar depois
    LD    HL,$9D95+((page_counter1 - meu_computador_main_task)-1);tenho o numero da pagina onde estou
    LD    A,(HL)
    OR    A \ jr   z,pagina_zero;se estou na pagina zero o icone e o numero do prog
    DEC   A;decremento uma pagina pois nao posso contar com a pagina onde estou
    LD    B,A
    XOR   A;apago o A
    LD    C,A;apago o C
start_conting:;comeco a contar o numero de paginas
    LD    A,C
    ADD   A,10;somo 10 por cada pagina
    DEC   B
    LD    C,A;salvo o A
    LD    A,B
    OR    A \ jr  nz,start_conting
    LD    A,C;paso o numero de programas para A pois vou restaurar o B e o C
pagina_zero:    
    POP   BC
    LD    C,A
    LD    A,B
    OR    A
    jp    z,((mudar_macrodie_nothing-meu_computador_main_task)-1)+$9D95
    LD    A,C
    ADD   A,B;somo o numero de programas com o numero do icone e obtenho o numero do programa que tenho de procurar
    LD    B,A
    LD   HL,((number_of_progs - meu_computador_main_task)-1)+$9D95
    LD    A,(HL)
    CP    B \ jp  c,((mudar_macrodie_nothing-meu_computador_main_task)-1)+$9D95
    
    LD    C,$18;tenho de procurar programas com shell de $18 'jr'
    XOR   A
    invoke( search_VAT_for_prog );retorna nome do programa em OP1
    jp    c,((mudar_macrodie_nothing-meu_computador_main_task)-1)+$9D95;caso esta flag esteja activa e porque o programa teve um erro e tem de voltar sem erros
    XOR   A
    invoke( CheckFreeMem );tenho de obter a memoria disponivel para nova tarefa o espaco livre vem em HL
    LD    (free_memory),HL;o espaco da memoria ram disponivel
    bcall _ChkFindSym;como a routina anterior obtem apenas programas nao preciso de fazer AND $1F
    LD    HL,$9D95+((macrodie_mouse - meu_computador_main_task)-1);se existir erro volto a traz
    jp    c,((mudar_macrodie_nothing-meu_computador_main_task)-1)+$9D95;caso esta flag esteja activa e porque o programa teve um erro e tem de voltar sem erros
    LD    A,$03
    
    LD    (type_of_task),A
    XOR   A
    invoke( compile_thread_to_mem );Inputs 
    XOR   A
    LD    (close_task),A
    LD    (screen),A
    LD    A,(last_activ_process)
    LD    (activ_task),A
    RET
scroll_up12:
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   A,(HL)
    OR   A \ jp   z,((mudar_macrodie_nothing-meu_computador_main_task)-1)+$9D95
    DEC  A
    LD   (HL),A
    OR   A
    PUSH AF
    XOR  A
    invoke( folder_ram_cleaner )
    LD   IX,$9D95+((_OP1_register_save - meu_computador_main_task)-1);11 bytes
    XOR  A
    invoke( restore_Op1_register_from_memory )
    
    LD   HL,$9D95+((counter2 - meu_computador_main_task)-1)
    LD   A,(HL);numero de progs em A
    LD   B,A
    LD   C,$18
    XOR  A
    invoke( search_VAT_UP_11_times );procura VAT em ordem ascendente
    XOR  A
    invoke( draw_bar )
    LD   HL,$9D95+((bar_size1 - meu_computador_main_task)-1)
    LD   A,(HL);lsb come first
    LD   E,A
    INC  HL
    LD   A,(HL)
    LD   D,A;msb comes now now i ve the bar size in DE
    LD   (bar_size),DE;the size have been restructured
    INC  HL;HL now points to scroll_x1
    LD   A,(HL)
    LD   (scroll_x),A
    INC  HL
    LD   A,(HL);HL now points to scroll_y1
    LD   (scroll_y),A
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   B,(HL)
    XOR  A
    invoke( update_scroll_pointer )
    LD   A,2
    LD   (scroll_x),A
    LD   A,17
    LD   (scroll_y),A
    LD   A,$18
    LD   (var_flag2),A;salvo o tipo de programa a procurar
    LD   A,10
    LD   (temp_C),A
    POP  AF
    LD   A,0
    jr   nz,do_not_invoke_10
    invoke( first_search_op1 )
do_not_invoke_10:    
    XOR  A
    invoke( searching_and_displaying )
    LD   IX,$9D95+((_OP1_register_save - meu_computador_main_task)-1);11 bytes
    XOR  A
    invoke( save_Op1_register_to_memory )
error_overflowed:
    jp   ((mudar_macrodie_nothing-meu_computador_main_task)-1)+$9D95
scroll_down12:    
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   A,(HL)
    LD   B,A; o numero da pagina actual em B
    LD   HL,$9D95+((page_counter2 - meu_computador_main_task)-1)
    LD   A,(HL);numero total de paginas em A
    CP   B \ jr  c,mudar_macrodie_nothing;nao pode acontecer 
           \ jr  z,mudar_macrodie_nothing;nao pode acontecer
    INC  B
    LD   A,B
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   (HL),A
    XOR  A
    invoke( folder_ram_cleaner )
    LD   IX,$9D95+((_OP1_register_save - meu_computador_main_task)-1);11 bytes
    PUSH IX
    XOR  A
    invoke( restore_Op1_register_from_memory )
    LD   A,$18
    PUSH AF
    PUSH HL
    LD   A,2
    LD   (scroll_x),A
    LD   A,17
    LD   (scroll_y),A
    POP  HL
    POP  AF
    LD   (var_flag2),A;salvo o tipo de programa a procurar
    LD   A,10
    LD   (temp_C),A
    LD   C,$18
    XOR  A
    invoke( searching_and_displaying )
    POP  IX
    PUSH BC;salvo a mensagem de erro
    XOR  A
    invoke( save_Op1_register_to_memory )
    POP  BC 
    LD   A,B
    CP   2 \ jr     z,mudar_macrodie_nothing
    XOR  A
    invoke( draw_bar )
    LD   HL,$9D95+((bar_size1 - meu_computador_main_task)-1)
    LD   A,(HL);lsb come first
    LD   E,A
    INC  HL
    LD   A,(HL)
    LD   D,A;msb comes now now i ve the bar size in DE
    LD   (bar_size),DE;the size have been restructured
    INC  HL;HL now points to scroll_x1
    LD   A,(HL)
    LD   (scroll_x),A
    INC  HL
    LD   A,(HL);HL now points to scroll_y1
    LD   (scroll_y),A
    LD   HL,$9D95+((page_counter1 - meu_computador_main_task)-1)
    LD   B,(HL)
    XOR  A
    invoke( update_scroll_pointer )    
mudar_macrodie_nothing:
    XOR  A
    invoke( loop )
    jp ((macrodie_mouse_verif - meu_computador_main_task)-1)+$9D95
mudar_para_macrodie:
    XOR  A
    invoke( mouse_sprite )
    jp   ((macrodie_mouse-meu_computador_main_task)-1)+$9D95
mudar_para_main:
    LD    HL,$9D95+((var1 - meu_computador_main_task)-1) ;aponta para a primeira variavel
    LD    A,1
    LD    (HL),A
;======================================
;========== MAIN MPC ==================
;======================================
main_activ:
     xor  a 
     invoke( create_default_pasta )
     xor  a
     invoke( draw_main_activ_pastas )
     XOR  A
     invoke( mouse )
task_main_loop:
     xor  a     
     invoke( window_verif_coords )
     LD   A,B
     CP   1 \ jr  z,fechar_tarefa
     CP   2 \ jr  z,minimizar_tarefa
     CP   3 \ jr  z,mudar_para_main_sem_alterar_rato
     CP   4 \ jr  z,mudar_para_main_sem_alterar_rato
     CP   5 \ jr  z,minimizar_tarefa
verificar_coords:;para terminar
     xor  a
     invoke( find_icone );retorna os valores em B por isso tenho de os passar para o acc
     LD   A,B
     CP   1 \ jr  z,macrodie_activ
     CP   2 \ jr  z,microprocessador1
     CP   3 \ jr  z,defenicoes_activ
     CP   6 \ jr  z,all_prgms_activ
     CP   7 \ jr  z,screensavers_activ
mudar_para_main_sem_alterar_rato:
     xor    a
     invoke( loop )
     jr     task_main_loop
;=============================
;=========== DECIDER =========
;=============================
;decide para onde vai o focus do programa 
macrodie_activ:
   LD    HL,$9D95+((var1 - meu_computador_main_task)-1)
   LD    (HL),1
   jp    ((continuar_process-meu_computador_main_task)-1)+$9D95  
defenicoes_activ:
   LD    HL,$9D95+((var1 - meu_computador_main_task)-1)
   LD    (HL),5
   jp    ((continuar_process-meu_computador_main_task)-1)+$9D95
all_prgms_activ:
   LD    HL,$9D95+((var1 - meu_computador_main_task)-1)
   LD    (HL),2
   jp    ((continuar_process-meu_computador_main_task)-1)+$9D95
microprocessador1:
   LD    HL,$9D95+((var1 - meu_computador_main_task)-1)
   LD    (HL),4
   jp    ((continuar_process-meu_computador_main_task)-1)+$9D95
screensavers_activ:
   LD    HL,$9D95+((var1 - meu_computador_main_task)-1)
   LD    (HL),3
   jp    ((continuar_process-meu_computador_main_task)-1)+$9D95
;=================================================================================
;==== Tarefas que uma janela deve realizar como maximizar minimizar e fechar  ====
;=================================================================================
fechar_tarefa:    
     LD   A,(activ_task)
     LD   (close_task),A ;ordem ao windows para fechar task     
     XOR  A
     LD   (activ_task),A
     LD   (screen),A ;erro causado por causa desta variavel
     LD   (animar_flag),A
     RET  ;volto ao windows 
minimizar_tarefa:
     LD    A,(activ_task)
     LD    HL,$9D95+((meu_computador_active_task-meu_computador_main_task)-1)
     LD    (HL),A
     XOR   A
     LD    (activ_task),A
     LD    (screen),A ; se nao apagarmos esta variavel o sistema recusa e desliga
     LD    (close_task),A
     RET   

 
background_mpc:
     RET

meu_computador_var .db $00
var1  .db $00
pastacoord1x .db $00
pastacoord1y .db $00
pastacoord2x .db $00
pastacoord2y .db $00
meu_computador_active_task .db $00
_OP1_register_save .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
bar_size1 .db $00,$00
scroll_x1 .db $00
scroll_y1 .db $00
page_counter1 .db $00;1 byte 
page_counter2 .db $00;1 byte
counter1 .db $00;1 byte
counter2 .db $00;1 byte
number_of_progs .db $00;1byte previne a execucao do vazio causa condigo aleatorio
CPU_name .db "Z80180",0;6+1
;screen frequency = 44Hz
screen_driver:  .db "Screen driver Toshiba T6A04",0;27+1
macrodie        .db "MacroDie OS 1.0",0;15+1
screen_freq:    .db "Screen Frequency 44Hz",0;21+1
macrodie_text:  .db "Macrodie",0;8+1
speed_6MHz:     .db "6MHz",0
speed_15MHz:    .db "15MHz",0
background_refresh .db "background speed",0
meu_computador_process_end:
;===================================================================
;=================== Meu computador process End ====================
;===================================================================
.end 