;================================
;==== reciclagem process init ===
;================================
reciclagem_init:
     LD   BC,reciclagem_end - OP1_register_saved 
reciclagem_main:
     LD   A,90
     LD   (scroll_x),A
     LD   A,6+9
     LD   (scroll_y),A;valores resetados por default
     LD    HL,$9D95+((reciclagem_var - reciclagem_main)-1)
     LD    A,(HL)
     CP    1 \ jr  z,continuar_process1
     LD    A,1
     LD    (HL),A
     LD    HL,$9D95+((background_reciclagem - reciclagem_main)-1)
     XOR   A
     invoke( ADD_program_to_background )
continuar_process1:
;agora crio a janela do windows
     XOR   A
     invoke( create_default_pasta )
;pasta criada no ambiente de trabalho
     
;ordem para procurar todos os programas na memoria
    XOR  A
    LD   B,A
    invoke( count_Prgms );retorna o valor de programas em A
    LD   C,A
    LD   A,B
    CP   2 \ jp   z,((delete_anulado - reciclagem_main)-1)+$9D95
    LD   A,C
    LD   HL,$9D95+((number_of_prgm - reciclagem_main)-1)
    LD   (HL),A;numero de progs salvo
    cp   11 \ PUSH AF;salvo o registo de flags  
            \ LD   B,A
            \ LD   A,0
              jr   c,do_not_invoke_11
            \ invoke( redraw_cursor_bar );redesenha a bar de deslocamento
do_not_invoke_11:            
            \ POP  AF
            \ PUSH AF
            \ jr   nc,do_not_erase_L4
              LD   L,2
do_not_erase_L4:  
              LD   A,L;numero de paginas na parte baixa de HL
              DEC  A
              LD   HL,$9D95+((page_area - reciclagem_main)-1)
              LD   (HL),A;numero de paginas salvo
              POP  AF;restauro o registo de flags
              LD   A,0;comeamos na pagina 0
              LD   B,A
              jr   c,redraw_screen_display2
            \ invoke( update_scroll_pointer )
redraw_screen_display2:
    LD   A,(scroll_x)
    LD   HL,$9D95+((scroll_x11 - reciclagem_main)-1)
    LD   (HL),A
    INC  HL
    LD   A,(scroll_y)
    LD   (HL),A
    DEC  HL
    DEC  HL
    DEC  HL
    PUSH HL
    LD   HL,(bar_size)
    EX   DE,HL;DE com o bar size
    POP  HL
    LD   A,E
    LD   (HL),A
    LD   A,D
    INC  HL
    LD   (HL),A
    LD   A,2
    LD   (scroll_x),A
    LD   A,14
    LD   (scroll_y),A
    ;DI;desactivo os interrupts o que causa a interrupcao de todos os programas activos mas tem de ser
    XOR  A
    LD   B,A
    
    invoke( search_and_display_programs )
    LD   A,B
  
    CP   2 \ jr z,reciclagem_mouse
    LD   IX,$9D95+((OP1_register_saved - reciclagem_main)-1);11 bytes
    XOR  A
    invoke( save_Op1_register_to_memory )
    LD   A,(temp_C);obtenho o numero de programas que sobrou possivelmente pode ser a ultima pagina e nao esta
    ;preenchida por isso obtenho o numero de programas que ficou por dispar e subtrai-o a 10
    LD   L,A
    LD   A,10
    SUB  L;faco a subtracao
    LD   HL,$9D95+((number_of_prgm2 - reciclagem_main)-1)
    LD   (HL),A    
reciclagem_mouse:
    XOR  A
    invoke( mouse )
reciclagem_main_loop:
    XOR  A
    invoke( window_verif_coords );se for isto entao vai normalmente para window
;verif coords
;    
     LD   A,B
     CP   1 \ jp  z,((close_task_recicl - reciclagem_main) - 1) + $9D95
     CP   2 \ jp  z,((minimizar_task_recicl - reciclagem_main) - 1) + $9D95
     XOR  A
     invoke( verif_scroll_bar )
     CP    1 \ jr   z,scroll_reciclagem_up
     CP    2 \ jp   z,((scroll_reciclagem_down - reciclagem_main) - 1) + $9D95
     XOR   A
     invoke( find_icone )
     LD    A,B
     OR    A \ jp  z,$9D95-1 
     ;pede a confirmacao para apagar o prgm
     PUSH   BC
     LD     HL,((reciclagem_msg - reciclagem_main) - 1) + $9D95
     XOR    A
     invoke( MsgBox_Ok )
     LD     A,B;get code
     POP    BC;B com o icone a apagar
     CP     2 \ jp   z,((delete_anulado - reciclagem_main) - 1) + $9D95 
     LD     HL,(( page_area - reciclagem_main) - 1) + $9D95
     PUSH   BC
     LD     A,(HL)
     OR     A \ jr  z,ignorar_pagina
     DEC    A
     LD     B,A
     XOR    A
pagina_x:
     ADD    A,10
     DJNZ   pagina_x
ignorar_pagina:
     POP    BC;B com o icone a apagar
     ADD    A,B;numero do prog em A
     LD     B,A
     XOR    A;not shelled prog
     LD     C,A
     invoke( search_VAT_for_prog );nome do prog retorna em OP1
     jp     c,((delete_anulado - reciclagem_main) - 1) + $9D95 
     ;lets delete it
     bcall  _ChkFindSym
     jp     c,((delete_anulado - reciclagem_main) - 1) + $9D95 
     bcall  _DelVarArc;variable structure deleted and it have been marked dirty till next garbage collection
     LD     HL,((prog_deleted - reciclagem_main) - 1) + $9D95
     XOR    A
     invoke( MsgBox_Ok )
     jp      $9D95 - 1 ;restaurando tudo
             
scroll_reciclagem_up:
    LD   HL,$9D95+((page_now - reciclagem_main)-1)
    LD   A,(HL)
    OR   A \ jp   z,((delete_anulado - reciclagem_main)-1)+$9D95
    DEC  A
    LD   (HL),A
    OR   A
    PUSH AF
    XOR  A
    invoke( folder_ram_cleaner )
    LD   IX,$9D95+((OP1_register_saved - reciclagem_main)-1);11 bytes
    XOR  A
    invoke( restore_Op1_register_from_memory )
    LD   HL,$9D95+((number_of_prgm2 - reciclagem_main)-1)
    LD   C,(HL);numero de progs em A
    ;LD   B,A
    XOR  A
    invoke( search_VAT_UP_11_times );procura VAT em ordem ascendente
    XOR  A
    invoke( draw_bar )
    LD   HL,$9D95+((barsize2 - reciclagem_main)-1)
    LD   A,(HL);lsb come first
    LD   E,A
    INC  HL
    LD   A,(HL)
    LD   D,A;msb comes now now i ve the bar size in DE
    LD   (bar_size),DE;the size have been restructured
    INC  HL;HL now points to scroll_x1
    LD   A,(HL)
    LD   (scroll_x),A
    INC  HL
    LD   A,(HL);HL now points to scroll_y1
    LD   (scroll_y),A
    LD   HL,$9D95+((page_now - reciclagem_main)-1)
    LD   B,(HL)
    XOR  A
    invoke( update_scroll_pointer )
    LD   A,2
    LD   (scroll_x),A
    LD   A,17
    LD   (scroll_y),A
    XOR  A
    LD   (var_flag2),A;salvo o tipo de programa a procurar
    LD   A,10
    LD   (temp_C),A
    POP  AF
    LD   A,0
    jr   nz,do_not_invoke_12
    invoke( first_search_op1 )
do_not_invoke_12:    
    XOR  A
    invoke( searching_and_displaying_1 )
    
    LD   IX,$9D95+((OP1_register_saved - reciclagem_main)-1);11 bytes
    XOR  A
    invoke( save_Op1_register_to_memory )
    LD   A,(temp_C);obtenho o numero de programas que sobrou possivelmente pode ser a ultima pagina e nao esta
    ;preenchida por isso obtenho o numero de programas que ficou por dispar e subtrai-o a 10
    LD   B,A
    LD   A,10
    SUB  B;faco a subtracao
    LD   HL,$9D95+((number_of_prgm2 - reciclagem_main)-1)
    LD   (HL),A
error_overflowed2:
    jp   ((delete_anulado - reciclagem_main)-1)+$9D95

scroll_reciclagem_down:    
    LD   HL,$9D95+((page_now - reciclagem_main)-1)
    LD   A,(HL)
    LD   B,A; o numero da pagina actual em B
    LD   HL,$9D95+((page_area - reciclagem_main)-1)
    LD   A,(HL);numero total de paginas em A
    CP   B \ jp  c,$9D95+ ((delete_anulado-reciclagem_main) - 1 );nao pode acontecer 
           \ jp  z,$9D95+ ((delete_anulado-reciclagem_main) - 1 );nao pode acontecer
    INC  B
    LD   A,B
    LD   HL,$9D95+((page_now - reciclagem_main)-1)
    LD   (HL),A
    XOR  A
    invoke( folder_ram_cleaner )
    LD   IX,$9D95+((OP1_register_saved - reciclagem_main)-1);11 bytes
    PUSH IX
    XOR  A
    invoke( restore_Op1_register_from_memory )
    LD   A,2
    LD   (scroll_x),A
    LD   A,17
    LD   (scroll_y),A
    XOR  A
    LD   (var_flag2),A;salvo o tipo de programa a procurar
    LD   A,10
    LD   (temp_C),A
    XOR  A
    invoke( searching_and_displaying_1 )
    POP  IX
    PUSH BC;salvo a mensagem de erro
    XOR  A
    invoke( save_Op1_register_to_memory )
    POP  BC 
    LD   A,B
    CP   2 \ jr     z,delete_anulado
    XOR  A
    invoke( draw_bar )
    LD   HL,$9D95+((barsize2 - reciclagem_main)-1)
    LD   A,(HL);lsb come first
    LD   E,A
    INC  HL
    LD   A,(HL)
    LD   D,A;msb comes now now i ve the bar size in DE
    LD   (bar_size),DE;the size have been restructured
    INC  HL;HL now points to scroll_x1
    LD   A,(HL)
    LD   (scroll_x),A
    INC  HL
    LD   A,(HL);HL now points to scroll_y1
    LD   (scroll_y),A
    LD   HL,$9D95+((page_now - reciclagem_main)-1)
    LD   B,(HL)
    XOR  A
    invoke( update_scroll_pointer )
    LD   A,(temp_C);obtenho o numero de programas que sobrou possivelmente pode ser a ultima pagina e nao esta
    ;preenchida por isso obtenho o numero de programas que ficou por dispar e subtrai-o a 10
    LD   B,A
    LD   A,10
    SUB  B;faco a subtracao
    LD   HL,$9D95+((number_of_prgm2 - reciclagem_main)-1)
    LD   (HL),A   
    jr   delete_anulado
close_task_recicl:
     LD   A,(activ_task)
     LD   (close_task),A ;ordem ao windows para fechar task     
     XOR  A
     LD   (activ_task),A
     LD   (screen),A ;erro causado por causa desta variavel
     LD   (animar_flag),A
     RET  ;volto ao windows 
     
minimizar_task_recicl:
     XOR   A
     LD    (activ_task),A
     LD    (screen),A ; se nao apagarmos esta variavel o sistema recusa e desliga
     LD    (close_task),A
     RET   


delete_anulado:
    LD    A,$FF
    OUT   (1),A
    XOR   A
    invoke( loop )  
    jp   ((reciclagem_main_loop - reciclagem_main) - 1) + $9D95
background_reciclagem:
    RET    
OP1_register_saved .db 0,0,0,0,0,0,0,0,0,0,0;11
barsize2           .db 0
                   .db 0
scroll_x11         .db 0
scroll_y11         .db 0
page_now           .db 0;pagina actual
page_area:         .db 0;um byte reservado    
number_of_prgm:    .db 0;counter1
number_of_prgm2:   .db 0;counter2
reciclagem_msg:    .db "Do you want to erase this prog???",0;34
prog_deleted:      .db "Program have been deleted",0;26
reciclagem_var     .db 0
reciclagem_end:



.end